<?php
/**
 * @daycounter.php 2020-04-12
 * @author Thomas E. Christoph info@webmaster-tenerife.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version: 1.0.2 FREE
 * @description: Joomla Plugin for display of counter days since or days until a certain date 
**/

//no direct access
defined( '_JEXEC' ) or die;

class plgContentDaycounter extends JPlugin
{
	/**
	 * Load the language file on instantiation. Note this is only available in Joomla 3.1 and higher.
	 * If you want to support 3.0 series you must override the constructor
	 *
	 * @var    boolean
	 * @since  3.1
	 */
	protected $autoloadLanguage = true;

	/**
	 * Plugin method with the same name as the event will be called automatically.
	 */

	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
		$live_site = JUri::base();
		$html = "";
		
		if (JPluginHelper::isEnabled('content', 'daycounter'))
		{
			$document = JFactory::getDocument();
			$doctype = $document->getType();
			if ($doctype == "html") $document->addCustomTag( $html );
		}

	}


	 
	public function onContentPrepare($context, &$row, &$params, $page = 0 )
	{

		if (JPluginHelper::isEnabled('content', 'daycounter'))
		{
			$row->text = $this->_daycounter($row->text);
			return true;

		} else {
			$row->text = preg_replace( '/{DAYCOUNTER[^}]*}/s','', $row->text );
			return true;
		}



	}

	 
	 function _daycounter($text)
	 {
		$regex = '/{DAYCOUNTER\s*.*?}/i';
		preg_match_all( $regex, $text, $matches );
		if(count($matches[0])>0){
			for($i=0;$i<count($matches[0]);$i++){
				$untilorsince = $this->params->get( 'daycounter_untilorsince' );
				$counterdate = $this->params->get( 'daycounter_date' );
				$date1 = new DateTime("today");
				$date2 = new dateTime($counterdate);
				if ($untilorsince == true) {
					$interval = date_diff($date2, $date1);
				} else {
					$interval = date_diff($date1, $date2);
				}
				$days = intval($interval->format('%R%a'));
				if ($days <= 0) {
					$output = JText::_('PLG_CONTENT_DAYCOUNTER_EXPIRED');
				} else {
					$output = $interval->format('%a');
					if ($days == 1) {
						$output .= ' ' . JText::_('PLG_CONTENT_DAYCOUNTER_DAY');
					} else {
						$output .= ' ' . JText::_('PLG_CONTENT_DAYCOUNTER_DAYS');
					}
				}
				$text = preg_replace($regex, $output, $text, 1);
			}
		}
		return $text;
	}

	protected function _getprm($str)
	{
		$bArr = array();
		$str = str_replace("&quot;", "\"", $str);
		$str = str_replace("&#34;", "\"", $str);
		$str = str_replace("€", "&euro;", $str);
		$str = str_replace("£", "&pound;", $str);
		$str = str_replace("¥", "&yen;", $str);
		preg_match_all('/[a-zA-Z0-9._%+-€|]+=\"(.*?)\"/', $str, $arr);

		if(!count($arr)) return false;

		foreach($arr[0] as $attr){
			$pieces = explode('=', $attr);
			$bArr[trim($pieces[0])] = substr(trim($pieces[1]),1,-1);
		}
		return $bArr;
	}

}
?>